#ifndef WALLIDEAL_H_INCLUDED
#define WALLIDEAL_H_INCLUDED

#include "polynomial.h"

Polynomial wallPolynomial(Polynomial const &p, IntegerVector const &wallNormal);
PolynomialSet wallIdeal(PolynomialSet const &groebnerBasis, IntegerVector const &wallNormal);
PolynomialSet lowerDimensionalWallIdeal(PolynomialSet const &groebnerBasis, IntegerVectorList const &wallEqualities);
//IntegerVectorList wallNormals(PolynomialSet const &groebnerBasis);
IntegerVectorList wallRemoveScaledInequalities(IntegerVectorList const &l);
IntegerVectorList wallInequalities(PolynomialSet const &groebnerBasis);
bool wallContainsPositiveVector(IntegerVector const &wallNormal);
PolynomialSet flip(PolynomialSet const &groebnerBasis, IntegerVector const &wallNormal);
PolynomialSet flipMinkowski(PolynomialSet const &groebnerBasis, IntegerVector const &wallNormal);
void wallAddCoordinateWalls(IntegerVectorList &normals, int n);
IntegerVectorList wallFlipableNormals(PolynomialSet const &groebnerBasis);

#endif
